module CGACOLOR(iIBGR, oR, oG, oB);

input [3:0] iIBGR; // Intensity, Blue, Green, Red
output reg [7:0] oR;
output reg [7:0] oG;
output reg [7:0] oB;

/*
// Very simple (and incorrect) colors
assign oR = {iIBGR[3],{7{iIBGR[0]}}};
assign oG = {iIBGR[3],{7{iIBGR[1]}}};
assign oB = {iIBGR[3],{7{iIBGR[2]}}};
*/

always @(iIBGR)
begin
	if (iIBGR[3]) // High intensity/ light colors
	begin
		oR = iIBGR[0] ? 'hff : 'h55; 
		oG = iIBGR[1] ? 'hff : 'h55;
		oB = iIBGR[2] ? 'hff : 'h55;
	end
	else
	begin
		if (iIBGR[2:0] == 3'b011)
		begin
			oR = 'haa; oG = 'h55; oB = 'h00; // Brown is an exception (darker green)
		end
		else // Regular colors
		begin
			oR = iIBGR[0] ? 'haa : 'h00; 
			oG = iIBGR[1] ? 'haa : 'h00;
			oB = iIBGR[2] ? 'haa : 'h00;
		end
	end		
end

endmodule
