module SCAN_DOUBLER(
	input SAMPLING_CLOCK, CGA_HSYNC, CGA_VSYNC,
	output reg [15:0] VGA_X,
	output reg VGA_CTRL_CLK,
	output reg [15:0] CGA_X,
	output reg CGA_SAMPLE_CLK,
	output reg writebuf,
	output reg vga_even
);

// Internal stuff
reg state_h2;
reg [15:0] CGA_SAMPLES_COUNT;
reg [3:0] divide_cnt;

always @ (posedge SAMPLING_CLOCK)
begin
	// Divide sampling clock
	
	divide_cnt <= divide_cnt + 1;
	
	if (divide_cnt == 0) // Divides SAMPLING_CLOCK by four
	begin
		divide_cnt <= 0;
		VGA_CTRL_CLK <= !VGA_CTRL_CLK;
		
				
		if (VGA_CTRL_CLK)
		begin
			VGA_X <= VGA_X + 1;
			// Divide VGA clock by two (for CGA sample clock)
			CGA_SAMPLE_CLK <= !CGA_SAMPLE_CLK;
			
		end	
		
		if (VGA_CTRL_CLK && CGA_SAMPLE_CLK)
		begin
			CGA_X <= CGA_X + 1;
		end
		
	end
	
	if (VGA_X >= CGA_SAMPLES_COUNT)
	begin
		if (vga_even)
		begin
			VGA_X <= CGA_SAMPLES_COUNT;
		end
		else
		begin
			VGA_X <= 0;
			vga_even <= 1;
		end
	end
	
	if (CGA_HSYNC)
	begin
		state_h2 <= 1;			
	end
	else
	begin
		// When HSYNC finishes, start from zero
		if (state_h2 == 1)
		begin
			CGA_SAMPLES_COUNT <= CGA_X;
			VGA_X <= 0;			
			state_h2 <= 0;
			writebuf <= !writebuf;	
			CGA_X <= 0;
			CGA_SAMPLE_CLK <= 0;
			VGA_CTRL_CLK <= 0;
			divide_cnt <= ~0;
			vga_even <= 0;
		end
	end
end

endmodule